<!-- video.js framework -->
<link href="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/video-js.min.css" rel="stylesheet">
<script src="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/video.min.js"></script>

<link href="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojs.vast.vpaid.min.css" rel="stylesheet" />

{% if downloadUrlsForMedia|length > 1 %}
<script src="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojs-contrib-quality-levels.min.js"></script>
{% endif %}

{% if downloadUrlsForMedia|length > 1 %}
<style>
    .quality-button-videojs .vjs-icon-placeholder:before {
        content: '';
        font-size: 12px;
        color: white;
    }
</style>
{% endif %}

<video
    id="main-video"
    class="video-js vjs-default-skin vjs-big-play-centered {{ IS_EMBED is defined ? 'vjs-fill' : 'vjs-16-9' }}"
    controls 
    preload="auto" 
    poster="{{ videoThumbnail|raw }}"
    data-setup='{}'
>
    <source src="{{ downloadUrlForMedia|raw }}" type="video/mp4" label="Fallback" res="360" />
    <p class="vjs-no-js">
      To view this video please enable JavaScript, and consider upgrading to a
      web browser that
      <a href="https://videojs.com/html5-video-support/" target="_blank"
        >supports HTML5 video</a
      >
    </p>
</video>

<!-- Ads plugin for video.js -->
<link href="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojs.ads.css" rel="stylesheet">
<script src="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojs.ads.min.js"></script>

<!-- This plugin for video.js -->
<link href="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojsx.vast.css" rel="stylesheet">
<script src="{{ WEB_ROOT }}/plugins/filepreviewer/assets/players/videojs/videojsx.vast.js"></script>

<script type="text/javascript">
var shouldTrackPlayedTime = {{ ackPercentage > 0 ? 'true' : 'false' }};
var ackPercentage = {{ ackPercentage|number_format }};
var playedTimeTracker = null;
var mediaTotalDuration = -1;
var totalPlayedTime = 0;
var isPlaying = false;

function waitForFn(fnName, fnCall) {
    var fn;
    try {
        eval("fn = " + fnName);
        if(fn){
            fnCall();
        } else{
            setTimeout(function(){waitForFn(fnName, fnCall);}, 50);
        }
    } catch(e){
        setTimeout(function(){waitForFn(fnName, fnCall);}, 50);
    }
}

$(document).ready(function() {
    var player = videojs('main-video', {
        controlBar: {
            children: [
                'playToggle',
                'volumePanel',
                'currentTimeDisplay',
                'timeDivider',
                'durationDisplay',
                'progressControl',
                'liveDisplay',
                'remainingTimeDisplay',
                'customControlSpacer',
                'playbackRateMenuButton',
                'fullscreenToggle'
            ]
        }
    });

    {% if downloadUrlsForMedia|length > 1 %}
        // Define your quality levels
        var qualityLevels = {{ videoToggleConfiguration|raw }};

        // Create quality selector button
        var QualityButton = videojs.getComponent('MenuButton');
        var QualityMenuItem = videojs.getComponent('MenuItem');

        var createQualityMenuItem = function(quality) {
            return new QualityMenuItem(player, {
                label: quality.label,
                selectable: true,
                selected: player.currentSrc() === quality.src
            });
        };

        var createQualityButton = function() {
            var button = new QualityButton(player, { text: 'Q' });
            button.addClass('quality-button-videojs'); // Add custom CSS class
            var menu = button.createMenu();

            qualityLevels.forEach(function(quality) {
                var menuItem = createQualityMenuItem(quality);
                menuItem.on('click', function() {
                    player.src({ src: quality.src, type: 'video/mp4' });
                    player.play();
                    // Update button label
                    button.el().querySelector('.vjs-icon-placeholder').innerText = quality.label;
                    // Hide the quality menu
                    button.removeClass('vjs-menu-button-popup'); // Remove the class to hide the menu
                    setTimeout(function() {
                        button.addClass('vjs-menu-button-popup'); // Add the class back after a short delay
                    }, 10);
                });
                menu.addItem(menuItem);
            });

            button.el().firstChild.appendChild(menu.el());

            // Set initial quality label
            var initialQuality = qualityLevels.find(function(quality) {
                return player.currentSrc() === quality.src;
            }) || qualityLevels[0];
            console.log(initialQuality.label);
            button.el().querySelector('.vjs-icon-placeholder').innerText = initialQuality.label;

            return button;
        };

        var qualityButton = createQualityButton();
        player.controlBar.addChild(qualityButton, { componentClass: 'quality-button' });

        // Listen for source change to update selected quality
        player.on('loadstart', function() {
            qualityButton.update();
        });
    {% endif %}

    waitForFn('videojs', function() {
        videojs.registerPlugin('ads-setup', function (opts) {
            var player = this;
            var adsCancelTimeout = 3000;

            var vastAd = player.vastClient({
                //Media tag URL
                adTagUrl: "http://pubads.g.doubleclick.net/gampad/ads?env=....",
                playAdAlways: true,
                //Note: As requested we set the preroll timeout at the same place than the adsCancelTimeout
                adCancelTimeout: adsCancelTimeout,
                adsEnabled: !!options.adsEnabled
            });
        });

        videojs('main-video').on("play", function () {
            isPlaying = true;
        });

        videojs('main-video').on("pause", function () {
            isPlaying = false;
        });

        // track total played in seconds
        playedTimeTracker = setInterval(trackPlayedTime, 5000);
    });
});

function trackPlayedTime() {
    if (shouldTrackPlayedTime == false) {
        // stop any future attempts of the timer
        clearInterval(playedTimeTracker);
        return false;
    }

    if (isPlaying == true) {
        // track actual played time
        totalPlayedTime = totalPlayedTime + 5;
    }

    if (mediaTotalDuration == -1) {
        // get total video length
        mediaTotalDuration = Math.round(videojs('main-video').duration());
    } 
    else {
        // calculate percentage
        percent = 0;
        if (totalPlayedTime > 0) {
            percent = (parseInt(totalPlayedTime) / parseInt(mediaTotalDuration)) * 100;
        }

        // should we log yet?
        if (percent >= ackPercentage) {
            // clear for next time
            shouldTrackPlayedTime = false;
            // log PPD
            $.ajax({
                method: "POST",
                url: "{{ WEB_ROOT }}/rewards/media_log_download_callback",
                data: {
                    fileId: "{{ file.id }}",
                    tracker: "{{ downloadUrlForMediaBase64|raw }}",
                    percent: percent
                }
            });
        }
    }
}
</script>

